import { INetRequest } from "../../script/Engine/CatanEngine/NetManagerV2/Core/INetRequest";
import { INetResponse } from "../../script/Engine/CatanEngine/NetManagerV2/Core/INetResponse";
import { ClientData } from "../../shared/protocols/define/interface";
import { RpcSlot1SpinRequest, RpcSlot1SpinResponse } from "../../shared/protocols/Slot1Request";


export default abstract class SlotFgSpinBase {
	public *fgspin(clientData: ClientData, req: INetRequest<RpcSlot1SpinRequest>): IterableIterator<any> {
		const data: RpcSlot1SpinRequest = req.Data
		const { count, freeData } = clientData.free;
		const slotData: any = freeData[count];

		const response: INetResponse<RpcSlot1SpinResponse> = {
			Status: 0,
			Method: req.Method,
			Data: slotData,
			IsValid: true
		};
		clientData.free.count++;
		return response;
	}
}