import { INetRequest } from "../../script/Engine/CatanEngine/NetManagerV2/Core/INetRequest";
import { INetResponse } from "../../script/Engine/CatanEngine/NetManagerV2/Core/INetResponse";
import { ClientData } from "../../shared/protocols/define/interface";
import { RpcSlotInRequest, RpcSlotInResponse } from "../../shared/protocols/SlotRequest";


export default abstract class SlotInBase {
	protected ver: string = "";
	protected abstract db: number;
	protected abstract br: number[];
	protected abstract jp: { [key: string]: number; };

	public *in(clientData: ClientData, req: INetRequest<RpcSlotInRequest>): IterableIterator<any> {
		const data: RpcSlotInRequest = req.Data;
		const { id } = data;
		const { ver, db, br, jp } = this;
		const response: INetResponse<RpcSlotInResponse> = {
			Status: 0,
			Method: req.Method,
			Data: { ver, db, br, jp },
			IsValid: true
		};
		return response;
	}
}