import { INetRequest } from "../../script/Engine/CatanEngine/NetManagerV2/Core/INetRequest";
import { INetResponse } from "../../script/Engine/CatanEngine/NetManagerV2/Core/INetResponse";
import { ClientData } from "../../shared/protocols/define/interface";
import { RpcSlotInRequest, RpcSlotInResponse } from "../../shared/protocols/SlotRequest";
import SlotIn1 from "../slot1/in";

export default function* (clientData: ClientData, req: INetRequest<RpcSlotInRequest>): IterableIterator<any> {
	const data: RpcSlotInRequest = req.Data;
	const { id } = data;

	let moduleClass: SlotIn1;
	let AsyncFunction = async function () {
		const module = await import(`../slot${id}/in`);
		moduleClass = new module.default();
	};
	AsyncFunction();
	while (!moduleClass) {
		yield;
	}
	const response: INetResponse<RpcSlotInResponse> = yield* moduleClass.in(clientData, req);
	return response;
}